
from PySteppables import *
import CompuCell


import sys
class CellDiffusionStetppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)
        self.com={} # empty dictionary
        self.rSq=[] #empty list
        import CompuCellSetup
        self.file=open("RSQ.txt","w")
        
    def start(self):
        # any code in the start function runs before MCS=0
        
        # iterating over all cells in simulation        
        for cell in self.cellList:
            self.com[cell.id]=(cell.xCOM,cell.yCOM, cell.zCOM)    
#                                     0      1          2
        

        
    def step(self,mcs):        
        print "Processing Monte Carlo Step: ", mcs
        
        totalDisplacement=0.0
        counter=0
        for cell in self.cellList:
        
            counter+=1
            
            xOrig=self.com[cell.id][0] 
            yOrig=self.com[cell.id][1]
            
            displacement=(cell.xCOM-xOrig)**2+(cell.yCOM-yOrig)**2
            
            totalDisplacement=totalDisplacement+displacement
#             totalDisplacement+=displacement

        averageRSq=totalDisplacement/counter        
        
        self.rSq.append([mcs,averageRSq])
        
        self.file.write("%d  %f\n" % (mcs,averageRSq/4) )
        
        print self.rSq
        
        
    def finish(self):
        # Finish Function gets called after the last MCS
        self.file.close()
        
        
        
        
        
        
        
        
        